package org.comefromchina.misc;

import java.lang.reflect.*;
import java.util.*;

import org.apache.commons.beanutils.BeanUtils;
import org.comefromchina.util.HtmlParser;
import org.comefromchina.util.WebGrabber;
import org.comefromchina.wiki.*;

public class OttawasNewestHomes {
	
	public final String indexPage = "http://www.ottawasnewesthomes.com/";

	public final String[][] mainElementObjectMap = new String[][] {
		{	
			"<span\\s+class=\'nav_menu\'[^>]*>.*?<a href=\"([^\"]+)\"[^>]*>([^<]+)</a>.*?</span>",
			"0",
			"name",
			"1"
		}
	};
	public final String[][] subElementObjectMap = new String[][] {
		{"doTopBuilder\\('(\\w+)'\\)", 	indexPage + "/builder-redirect.php?bldSrc=bldPg&bldNam=", 	"pre\\s+=\\s+\"([^\"]+).*?pre\\+\"([^\"]+)", 	"bi", 		"website", 				"String"},
		{"doBBB\\('(\\w+)'\\)", 		indexPage + "/bbb-redirect.php?bldNam=", 					"this.location.href\\s+=\\s+\"([^\"]+)\"", 		"si", 		"bbbReportLink", 		"String"},
		{"doTarion\\('(\\w+)'\\)", 		indexPage + "/tarion-redirect.php?bldNam=", 				"this.location.href\\s+=\\s+\"([^\"]+)\"", 		"si", 		"tarionReportLink", 	"String"},
		{"doJDP\\('(\\w+)'\\)", 		indexPage + "/jdp-redirect.php?bldNam=", 					"this.location.href\\s+=\\s+\"([^\"]+)\"", 		"si", 		"JDPowerReportLink", 	"String"},
		{"<td class='TbBd[^>]*>(.*?)</td>",	null,	null,		"col-org.comefromchina.wiki.Community",	"newCommunity", 		"HashSet"},
		{"<BLOCKQUOTE>(.+?)</BLOCKQUOTE>", null, null,																								"si",		"description",			"String"}
	};
	
	public static void main(String[] args) {
		OttawasNewestHomes home = new OttawasNewestHomes();
		HashMap<String, Builder> builders = new HashMap<String, Builder>();		
		try{			
			StringBuilder sb = WebGrabber.fetch(home.indexPage); 
			ArrayList<String[]> retVal = HtmlParser.getCollectionOfValues(sb.toString(), home.mainElementObjectMap[0][0], home.indexPage);
			sb = null;
			if (retVal != null && retVal.size() > 0) {
				for (int i=0; i<retVal.size(); i++) {
					String[] values = retVal.get(i);
					int nextClawIndex = Integer.parseInt(home.mainElementObjectMap[0][1]);
					int valueIndex = Integer.parseInt(home.mainElementObjectMap[0][3]);
					String key = values[valueIndex];
					System.out.println("processing : " + values[0]);
					if (builders.get(key) == null) {
						System.out.println("processing : " + key);
						Builder b = new Builder();
						BeanUtils.setProperty(b, home.mainElementObjectMap[0][2], values[valueIndex]);
						sb = WebGrabber.fetch(values[nextClawIndex]);
						
						for (int j=0; j<home.subElementObjectMap.length; j++) {
							if (home.subElementObjectMap[j][1] == null) {
								if (home.subElementObjectMap[j][3].contains("col")) {									
									ArrayList<String[]> ret = HtmlParser.getCollectionOfValues(sb.toString(), home.subElementObjectMap[j][0], null);
									String[] tmp = home.subElementObjectMap[j][3].split("-");
									String ClassName = tmp[1];
									
									ArrayList<String> flatternRet = new ArrayList<String>();
									for (int n=0; n<ret.size(); n ++) {
						            	String[] vals = ret.get(n);
						            	for (int m=0; m<vals.length; m++) {
						            		flatternRet.add(vals[m]);
						            	}
						            }
						            HashSet dataSet = new HashSet();
							        try {
							        	Class c = Class.forName(ClassName);
							            Field fieldlist[] = c.getDeclaredFields();
							            int argLength = fieldlist.length;
							            Class partypes[] = new Class[argLength];
							            for (int g=0; g<argLength; g++) {
							            	partypes[g] = String.class;
							            }							           
							            Constructor ct = c.getConstructor(partypes);
							            int flatternSize = (flatternRet.size() - (flatternRet.size() % argLength)) / argLength;

							            for (int k=0; k<flatternSize; k++) {
								            Object arglist[] = new Object[argLength];
								            for (int g=0; g<argLength; g++) {
								            	arglist[g] = flatternRet.get(k * argLength + g);
								            }
								            Object retobj = ct.newInstance(arglist);
								            dataSet.add(retobj);
							            }
							            
							        } catch (Throwable e) {
							             System.err.println(e);
							        }
							        BeanUtils.setProperty(b, home.subElementObjectMap[j][4], dataSet);
								} else {
									String retSubVal = null;
									if ("si".equals(home.subElementObjectMap[j][3])){
										retSubVal = HtmlParser.getSingleValue(sb.toString(), home.subElementObjectMap[j][0]);
									} else if ("bi".equals(home.subElementObjectMap[j][3])){
										retSubVal = HtmlParser.getBiValue(sb.toString(), home.subElementObjectMap[j][0]);
									}
									if (retSubVal != null && retSubVal != "") {
										BeanUtils.setProperty(b, home.subElementObjectMap[j][4], retSubVal);
									}
								}
							} else {
								String retSubVal = HtmlParser.getSingleValue(sb.toString(), home.subElementObjectMap[j][0]);
								if (retSubVal != null && retSubVal != "") {
									StringBuilder subContent = WebGrabber.fetch(home.subElementObjectMap[j][1] + retSubVal);
									if ("si".equals(home.subElementObjectMap[j][3])){
										retSubVal = HtmlParser.getSingleValue(subContent.toString(), home.subElementObjectMap[j][2]);
									} else if ("bi".equals(home.subElementObjectMap[j][3])){
										retSubVal = HtmlParser.getBiValue(subContent.toString(), home.subElementObjectMap[j][2]);
									}
									subContent = null;
									if (retSubVal != null && retSubVal != "") {
										BeanUtils.setProperty(b, home.subElementObjectMap[j][4], retSubVal);
									}
								}
							}
						}
						builders.put(key, b);
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		List<String>keys = new ArrayList<String>(builders.keySet());
		Collections.sort(keys, String.CASE_INSENSITIVE_ORDER);

		for (int i=0; i<keys.size(); i++) {
			String key = keys.get(i);
			System.out.println(builders.get(key));
		}
	}
}
