package org.comefromchina.util;

import java.util.*;
import java.util.regex.*;

public class HtmlParser {

	static public String getSingleValue(String content, String pattern) {
		return getValueByIndex(content, pattern, 1);
	}
	
	static public String getBiValue(String content, String pattern) {
		Pattern datePatt = Pattern.compile(pattern, Pattern.MULTILINE | Pattern.CASE_INSENSITIVE | Pattern.DOTALL | Pattern.UNIX_LINES);
		Matcher m = datePatt.matcher(content);
		String ret = "";
		if (m.find()) { 
			ret = m.group(1) + m.group(2);
		}
		return ret;
	}
	
	static public String getValueByIndex(String content, String pattern, int index) {
		Pattern datePatt = Pattern.compile(pattern, Pattern.MULTILINE | Pattern.CASE_INSENSITIVE | Pattern.DOTALL | Pattern.UNIX_LINES);
		Matcher m = datePatt.matcher(content);
		String ret = "";
		if (m.find()) { 
			ret = m.group(index);
		}
		return ret;
	}
	
	static public ArrayList<String[]> getCollectionOfValues(String content, String pattern, String validation) {
		ArrayList<String[]> ret = new ArrayList<String[]>();
		Pattern datePatt = Pattern.compile(pattern, Pattern.MULTILINE | Pattern.CASE_INSENSITIVE | Pattern.DOTALL | Pattern.UNIX_LINES);
		Matcher m = datePatt.matcher(content);
		while (m.find()) {
			int size = m.groupCount();
			ArrayList<String> objs = new ArrayList<String>();
			boolean validate = false;
			for (int i=1; size > 0 && i<size + 1; i++) {
				String data = m.group(i);
				if (data != null) {
					data = data.replaceAll("<a href[^>]*>|</a>|&nbsp;|<img[^>]*>|<strong>|</strong>|<font[^>]*>|</font>", "");
					objs.add(data.trim());
					if (validation != null && data.contains(validation)) {
						validate = true;
					}
				}
			}
			if (validation == null || validate) {
				ret.add(objs.toArray(new String[0]));
			} else {
				objs = null;
			}
		}
		return ret;
	}
}
